/*----------------------------------------------------------------.
| Xeyes clone for SMS/QDOS                                        |
|                                                                 |
| Mainly written (TI5375 laptop, Linux/xtc68 & uqlx) on the South |
| West Trains 16:40 Poole <-> Southampton service 31/12/96        |
|                                                                 |
| Free and freely distributable by Jonathan R Hudson              |
| jrhudson@bigfoot.com                                            |
`----------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include <math.h>

char _prog_name[] = "Qeyes";
char _version[] = "0.01";

long (*_cmdchannels) (long) = NULL;
long (*_stackchannels) (long) = NULL;
void (*_consetup) (chanid_t,struct WINDOWDEF *) = NULL;
long (*_conread) () = NULL;
long (*_conwrite) () = NULL;
char *_endmsg = NULL;

/*
   Define the scale and some colours. Would be nice to make these
   configurable later.

   Backing is the paper colour of the box behind the eyes
   Whites  is the colour of the "white" of the eyes
   Mascara is the colour of the border round the eyes ;-)

   All the sizes/positions are generated from "Scale", and because the
   QL graphics are scaled it makes the rest rather easy, except that I
   have no idea how to calculate the window width. I worked it out to be
   2.86 * Scale, purely by trial and error. Presumably if my maths and/or
   trigonometry were better....

   Also, since scale turned out to be the answer to life the universe and
   everything, a default of 42 somehow seemed appropriate
*/

#define Scale   18
#define Mascara 255
#define Backing 8
#define Whites  7
#define Win_Wid (2.86 * Scale)
#define Win_Hgt (2 * Scale)
#define RADIUS (Scale/2.5)
#define EX0 (ww.xsize/4)
#define EX1 ((3*ww.xsize)/4)
#define EY  (ww.ysize/2)

extern struct WM_sprite mes_beye, mes_weye;

static struct WM_wstat ws =     /* window status area */
{
    NULL,                       /* *wwork point back to work def */
    NULL,                       /* *wdef this was wdef */
    0,                          /* chid chan ID enclosing pointer */
    0, 0, 0,                    /* swnr, xpos, ypos sub-window and ptr posn */
    0, 0,                       /* kstk, kprs key stroke and press */
    0,                          /* evnt event vector */
    0, 0, 0, 0,                 /* xsiz, ysiz, xorg, yorg  */
    0, 0,                       /* ptpsx, ptpsy pointer position (abs) */
    FORM_QL4, 0, 0,             /* wmode, 2 spare window mode and spare */
    NULL,                       /* *ciact current item "action" */
    -1,                         /* citem  current item */
    0, 0, 0,                    /* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,                 /* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}    /* litem[40] loose item status */
};
static struct WM_wwork ww =     /* window working definition */
{
    NULL,                       /* *wstat pointer to status area */
    NULL,                       /* *wscale this was pointer to WDEF */
    0,                          /* chid channel ID */
    NULL,                       /* *pprec pointer to pointer record */
    0,                          /* psave pointer position saved */
    0, 0, 0, 0,                 /* 4 zero */
    NULL,                       /* *splst pointer to sprite list */
    Win_Wid,Win_Hgt,            /* xsize, ysize         size */
    0, 0,                       /* xorg, yorg           and origin */
    0,                          /* flag no clear + shadow */
    0, 0, Backing,              /* borw, borc, papr border width/clr, paper */
    NULL,                       /* *sprite  pointer to sprite */
    1, CL_MHIGH,                /* curw, curc current item width/clr */
    CL_MPUNAV, CL_MIUNAV, NULL, NULL, /* uback, uink, *ublob, *upatt unavail */
    CL_BPAVBL, CL_BIAVBL, NULL, NULL, /* aback, aink, *ablob, *apatt avail */
    CL_BPSLCT, CL_BISLCT, NULL, NULL, /* sback, sink, *sblob, *spatt selected */
    NULL,                       /* *help */
    0,0,NULL,                   /* ninfo, ninob, *pinfo info winds */
    0, NULL,                    /* nlitm, *plitm loose items */
    0, NULL                     /* nappl  *pappl appl winds */
};


typedef struct 
{
    short ex;                   /* centre of pupil */
    short ey;                   /*        "        */
    short px;                   /* actual pupil position */
    short py;                   /*        "              */
    short ox;                   /* previous position     */
    short oy;                   /* (for blanking)        */
} IPos_t;


/*----------------------------------------.
| just done by simple 'similar triangles' |
`----------------------------------------*/

void pupilpos(IPos_t *ip, short mx, short my)
{
    short dx,dy;
    short s, r;
    
    dx = mx - ww.xorg - ip->ex;
    dy = my - ww.yorg - ip->ey;
    r = (short) sqrt((double)(dx*dx + dy*dy));
    s = (r > 50) ? RADIUS : RADIUS-2;
    
    ip->px = (r) ? dx * s / r : 0;
    ip->py = (r) ? dy * s / r : 0;
    ip->px += ip->ex;
    ip->py += ip->ey;    
    if(ip->ox != ip->px || ip->oy != ip->py)
    {
        iop_wspt (ww.chid, -1, ip->ox, ip->oy, &mes_weye);
        iop_wspt (ww.chid, -1, ip->px, ip->py, &mes_beye);
        ip->ox = ip->px;
        ip->oy = ip->py;
    }
}
void eyes(void)
{
    /*
        New bit, draw some pretty eyes using ellipses
    */
        sd_setin(ww.chid, -1, Mascara);
        sd_flood(ww.chid, -1, 1);
        sd_elipse(ww.chid,-1, (double)25, (double)50, (double)0.5, (double)50, (double)0);
        sd_setin(ww.chid, -1, Whites);
        sd_flood(ww.chid, -1, 1);
        sd_elipse(ww.chid,-1, (double)25, (double)50, (double)0.5, (double)43, (double)0);
        sd_setin(ww.chid, -1, Mascara);
        sd_flood(ww.chid, -1, 1);
        sd_elipse(ww.chid,-1, (double)80, (double)50, (double)0.5, (double)50, (double)0);
        sd_setin(ww.chid, -1, Whites);
        sd_flood(ww.chid, -1, 1);
        sd_elipse(ww.chid,-1, (double)80, (double)50, (double)0.5, (double)43, (double)0);
        sd_flood(ww.chid, -1, 0);
}

int main(void)
{
    extern unsigned short scrX, scrY;
    
    IPos_t eye[2];
    short ib, xp=0, yp=0;
    WM_prec_t prec;
    int res;

    (eye+0)->ox = (eye+1)->ox = -1;
    (eye+0)->ex = EX0 ;
    (eye+1)->ex = EX1 ;
    (eye+0)->ey = (eye+1)->ey = EY ;
    
    ws.wwork = &ww;
    ww.wstat = &ws;
    ww.chid = io_open("scr", 0);

    if (!(wm_findv (ww.chid)))
    {
        return -1;
    }

    ib = ((scrX == 0xffff) && (scrY == 0));
    res = (ib) ? bt_prpos (&ww) : wm_prpos (&ww, scrX, scrY);

    if(res == 0)
    {
        short lx = 0,ly = 0;
        wm_wdraw (&ww);
        wm_swinf(&ww, 0, 0);

        eyes();

        while(1)
        {
            res = iop_rptr(ww.chid, -1, &xp, &yp, 0x19, &prec);

            if(prec.evnt & 1)
            {
                if(prec.kstk == 2)
                {
                    if(ib == 1)
                        bt_free();
                    bt_prpos(&ww);
                    wm_wdraw(&ww);
                    eyes();
                    ib = 1;
                }
                else if (prec.kstk == 1)
                {
                    short dx=xp,dy=yp;

                    if(ib)
                    {
                        bt_free();
                        ib = 0;
                    }
                    res = iop_rptr(ww.chid, -1, &dx, &dy, 0x81, &prec);
                    wm_unset(&ww);
                    ww.xorg = 0;
                    ww.yorg = 0;
                    wm_prpos (&ww, dx-3, dy-3);
                    wm_wdraw (&ww);
                    eyes();
                }
                else if(prec.kstk == 27)
                {
                    break;
                }
		else if(prec.kstk)
		{
		    wm_wdraw(&ww);
                    eyes();
		}
            }

            if((prec.evnt & 8) || xp != lx || yp != ly)
            {
                lx = xp;
                ly = yp;
                pupilpos(eye, xp, yp);
                pupilpos(eye+1, xp, yp);
            }
        
            if(!(prec.evnt & 0x20))
            {
                mt_susjb(-1, 10, NULL);
            }
        }
    }
    return 0;
}
int (*_Cstart) () = main;




