/*----------------------------------------------------------------.
| Xeyes clone for SMS/QDOS                                        |
|                                                                 |
| Mainly written (TI5375 laptop, Linux/xtc68 & uqlx) on the South |
| West Trains 16:40 Poole <-> Southampton service 31/12/96        |
|                                                                 |
| Free and freely distributable by Jonathan R Hudson              |
| jrhudson@bigfoot.com	                                          |
|                                                                 |
| Modified by Phil Borman to use ellipses for eyes so it looks    |
| more like it's Xeyes counterpart, made scaleable, and made      |
| colours and scale configurable, and scaleable circles as pupils |
`----------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include <math.h>

char _prog_name[] = "Qeyes";
char _version[] = "0.02";

long (*_cmdchannels) (long) = NULL;
long (*_stackchannels) (long) = NULL;
void (*_consetup) (chanid_t,struct WINDOWDEF *) = NULL;
long (*_conread) () = NULL;
long (*_conwrite) () = NULL;
char *_endmsg = NULL;

short   Scale;
short   Radius;
WM_sprite_t *bptr, *wptr;


static struct WM_wstat ws =     /* window status area */
{
    NULL,                       /* *wwork point back to work def */
    NULL,                       /* *wdef this was wdef */
    0,                          /* chid chan ID enclosing pointer */
    0, 0, 0,                    /* swnr, xpos, ypos sub-window and ptr posn */
    0, 0,                       /* kstk, kprs key stroke and press */
    0,                          /* evnt event vector */
    0, 0, 0, 0,                 /* xsiz, ysiz, xorg, yorg  */
    0, 0,                       /* ptpsx, ptpsy pointer position (abs) */
    FORM_QL4, 0, 0,             /* wmode, 2 spare window mode and spare */
    NULL,                       /* *ciact current item "action" */
    -1,                         /* citem  current item */
    0, 0, 0,                    /* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,                 /* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}    /* litem[40] loose item status */
};
static struct WM_wwork ww =     /* window working definition */
{
    NULL,                       /* *wstat pointer to status area */
    NULL,                       /* *wscale this was pointer to WDEF */
    0,                          /* chid channel ID */
    NULL,                       /* *pprec pointer to pointer record */
    0,                          /* psave pointer position saved */
    0, 0, 0, 0,                 /* 4 zero */
    NULL,                       /* *splst pointer to sprite list */
    2,1,                        /* xsize, ysize         size */
    0, 0,                       /* xorg, yorg           and origin */
    0,                          /* flag no clear + shadow */
    0, 0, 0,                    /* borw, borc, papr border width/clr, paper */
    NULL,                       /* *sprite  pointer to sprite */
    1, CL_MHIGH,                /* curw, curc current item width/clr */
    CL_MPUNAV, CL_MIUNAV, NULL, NULL, /* uback, uink, *ublob, *upatt unavail */
    CL_BPAVBL, CL_BIAVBL, NULL, NULL, /* aback, aink, *ablob, *apatt avail */
    CL_BPSLCT, CL_BISLCT, NULL, NULL, /* sback, sink, *sblob, *spatt selected */
    NULL,                       /* *help */
    0,0,NULL,                   /* ninfo, ninob, *pinfo info winds */
    0, NULL,                    /* nlitm, *plitm loose items */
    0, NULL                     /* nappl  *pappl appl winds */
};


typedef struct 
{
    short ex;                   /* centre of pupil */
    short ey;                   /*        "        */
    short px;                   /* actual pupil position */
    short py;                   /*        "              */
    short ox;                   /* previous position     */
    short oy;                   /* (for blanking)        */
} IPos_t;


/*----------------------------------------.
| just done by simple 'similar triangles' |
`----------------------------------------*/

void pupilpos(IPos_t *ip, short mx, short my)
{
    short dx,dy;
    short s, r;
    
    dx = mx - ww.xorg - ip->ex;
    dy = my - ww.yorg - ip->ey;
    r = (short) sqrt((double)(dx*dx + dy*dy));
    s = (r > 50) ? Radius : Radius-2;

    ip->px = (r) ? dx * s / r : 0;
    ip->py = (r) ? dy * s / r : 0;
    ip->px += ip->ex;
    ip->py += ip->ey;    
    if(ip->ox != ip->px || ip->oy != ip->py)
    {
        iop_wspt (ww.chid, -1, ip->ox, ip->oy, wptr);
        iop_wspt (ww.chid, -1, ip->px, ip->py, bptr);
        ip->ox = ip->px;
        ip->oy = ip->py;
    }
}
void eyes(void)
{
    /*
        draw some pretty eyes using ellipses
    */
        extern unsigned short scrM;

        sd_setin(ww.chid, -1, scrM);
        sd_flood(ww.chid, -1, 1);
        sd_elipse(ww.chid,-1, (double)25, (double)50, (double)0.5, (double)50, (double)0);
        sd_setin(ww.chid, -1, 7);
        sd_flood(ww.chid, -1, 1);
        sd_elipse(ww.chid,-1, (double)25, (double)50, (double)0.5, (double)43, (double)0);
        sd_setin(ww.chid, -1, scrM);
        sd_flood(ww.chid, -1, 1);
        sd_elipse(ww.chid,-1, (double)80, (double)50, (double)0.5, (double)50, (double)0);
        sd_setin(ww.chid, -1, 7);
        sd_flood(ww.chid, -1, 1);
        sd_elipse(ww.chid,-1, (double)80, (double)50, (double)0.5, (double)43, (double)0);
        sd_flood(ww.chid, -1, 0);
}

void pupils(void)
{
/*
   Unfortunately the pupils DO have to be sprites, as drawing filled circles
   in real-time takes far too long, and using a white outline round a black
   pupil fails if the pupil jumps position, so I'd better build some circle
   sprites the right size.
   Problem is, due to the very simple algorithm used to find the circle's
   limits, small circles are not very circular, and can be a bit spiky.
*/
char  *p,*col,*msk,*bsp,*wsp;
int   sz,centre,limit,w,h,x,y;
int   nlw,mem;
short *sptr;
long  *lptr;
char  bit;
unsigned char byte;

   sz = 1+ (Scale/4);           /* pupil size */
   if (sz < 6)                  /* no smaller than this */
       sz = 6;                  /* so limit is never 1 */

   centre = sz/2;               /* origin is in the middle */

   /* the circle is defined by (x squared + y squared) = radius squared */

   limit = centre-1;
   limit *= limit;

   nlw = sz/16;                 /* work out how many longwords wide       */
   nlw++;                       /* the sprite will be (sprite definitions */
                                /* are arranged in longwords)             */

   mem = nlw * sz * (4*2);      /* two images, one colour, one mask       */
   mem += (24*2);               /* two 24 byte headers, one per sprite    */

   p = malloc(mem);             /* memory for layout, zero filled */
   wsp = p;                     /* white sprite here */

   sptr = (short *)p;
   *sptr++ = 0x0100;            /* sprite header */
   *sptr++ = 0x0000;
   *sptr++ = sz;                /* size */
   *sptr++ = sz;
   *sptr++ = centre;            /* origin */
   *sptr++ = centre;
   lptr = (long *)sptr;
   *lptr++ = 0;                 /* colour */
   *lptr++ = 0;                 /* mask */
   *lptr++ = 0;                 /* next */

   bsp = (char *)lptr;          /* black sprite here */
   sptr = (short *)lptr;
   *sptr++ = 0x0100;            /* sprite header */
   *sptr++ = 0x0000;
   *sptr++ = sz;                /* size */
   *sptr++ = sz;
   *sptr++ = centre;            /* origin */
   *sptr++ = centre;
   lptr = (long *)sptr;
   *lptr++ = 0x0000000c;        /* colour */
   *lptr++ = 0;                 /* mask */
   *lptr++ = 0;                 /* next */

   col = (char *)lptr;

   for (h=0; h<(nlw*sz);h++)    /* write out colour */
     *lptr++ = 0;

   msk = (char *)lptr;

   lptr = (long *)wsp;          /* patch in the relative pointers */
   lptr += 3;
   p    = (char *)lptr;
   *lptr = (msk - p);           /* white sprite has ptr to mask,mask */
   lptr ++;
   p    = (char *)lptr;
   *lptr = (msk - p);

   lptr = (long *)bsp;          /* black sprite has ptr to col,mask */
   lptr += 4;
   p    = (char *)lptr;
   *lptr = (msk - p);


   p = msk;

/*
   Now the tricky bit - generate the pattern mask.
   It can probably be done more neatly than this.
*/

   bit  = 7;
   byte = 0;
   for (h=1;h<=sz;h++)
   {
     for (w=1;w<=nlw*16;w++)
     {
       bit--;
       if (bit < 0)
       {
         *p++ = byte;
         *p++ = byte;
         bit  = 7;
         byte = 0;
       }
       x = abs(w-centre);
       y = abs(h-centre);
       if (sz < 10)             /* small circles use the edge, or else
                                   they end up square! */
       {
         if ((x*x)+(y*y) <= limit)          /* if the pixel is inside  */
             byte = byte | (1 << bit);      /* set the relevant bit */
       }
       else                     /* larger circles use the inside */
       {
         if ((x*x)+(y*y) < limit)           /* if the pixel is inside  */
             byte = byte | (1 << bit);      /* set the relevant bit */
       }
     }
   }

   bptr = (WM_sprite_t*)bsp;
   wptr = (WM_sprite_t*)wsp;
}

int main(int ac, char **av)
{
    extern unsigned short scrX, scrY, scrS, scrP;
    char *sp;
    short nc;
    unsigned short xpos,ypos;
    
    IPos_t eye[2];
    short ib, xp=0, yp=0;
    WM_prec_t prec;
    int res;

    Scale = 0;

    ac = ac;                    /* to keep compiler happy */
    sp = *(av+1);
    nc = *((short *)sp);        /* skip any channels passed */
    sp += 2;
    sp += (nc << 2);
    nc = *((short *)sp);        /* is there a command line ? */
    sp += 2;

    if (nc)
    {
      *(sp+nc) = '\0';
      Scale = atoi(sp);         /* if so, read it as a number */
      if (Scale <= 0)           /* use configged value if invalid or missing */
        Scale = scrS;

      xpos = scrX;              /* use configged values as default position */
      ypos = scrY;

      sp = strchr(sp,' ');      /* override if any supplied position values */
      if (sp != NULL)
      {
        xpos = atoi(sp);
        sp = strchr(sp,'x');
        if (sp != NULL)
          ypos = atoi(sp+1);
      }
    }
    else
    {
      Scale = scrS;             /* use configged values if no command line */
      xpos  = scrX;
      ypos  = scrY;
    }
    ww.xsize = (short) (Scale * 2.86);
    ww.ysize = (short) (Scale * 2);
    Radius   = (short) (Scale / 2.5);
    ww.papr  = scrP;

    (eye+0)->ox = (eye+1)->ox = -1;
    (eye+0)->ex = (Scale*2.86*0.25);
    (eye+1)->ex = ww.xsize-(eye+0)->ex;
    (eye+0)->ey = (eye+1)->ey = Scale ;
    ws.wwork = &ww;
    ww.wstat = &ws;
    ww.chid = io_open("scr_2x1a0x0", 0);

    if (!(wm_findv (ww.chid)))
    {
        return -1;
    }

    res = -1;

    ib = ((xpos == 0xffff) && (ypos == 0));     /* magic numbers meaning
                                                   "put in button frame" */
    if (ib)
    {
      res = bt_prpos (&ww);
    }
    if (res != 0)                               /* but if that fails.... */
    {
      res = wm_prpos (&ww, xpos, ypos);
    }
    if(res == 0)
    {
        short lx = 0,ly = 0;
        wm_wdraw (&ww);
        wm_swinf(&ww, 0, 0);

        pupils();
        eyes();

        while(1)
        {
            res = iop_rptr(ww.chid, -1, &xp, &yp, 0x19, &prec);

            if(prec.evnt & 1)
            {
                if(prec.kstk == 2)
                {
                    if(ib == 1)
                        bt_free();
                    bt_prpos(&ww);
                    wm_wdraw(&ww);
                    eyes();
                    ib = 1;
                }
                else if (prec.kstk == 1)
                {
                    short dx=xp,dy=yp;

                    if(ib)
                    {
                        bt_free();
                        ib = 0;
                    }
                    res = iop_rptr(ww.chid, -1, &dx, &dy, 0x81, &prec);
                    wm_unset(&ww);
                    ww.xorg = 0;
                    ww.yorg = 0;
                    wm_prpos (&ww, dx-3, dy-3);
                    wm_wdraw (&ww);
                    eyes();
                }
                else if(prec.kstk == 27)
                {
                    break;
                }
            }

            if((prec.evnt & 8) || xp != lx || yp != ly)
            {
                lx = xp;
                ly = yp;
                pupilpos(eye, xp, yp);
                pupilpos(eye+1, xp, yp);
            }
        
            if(!(prec.evnt & 0x20))
            {
                mt_susjb(-1, 10, NULL);
            }
        }
    }
    return 0;
}
int (*_Cstart) () = main;
